# -*- coding: utf8 -*-
from builtins import object
from pyramid.view import view_config
from euhu.programs.pwe import to_bmas, validate
from pwe.model.participation import PWEParticipation as Participation

from ringo_bmasreport.reports.sachbericht import (
    filters, indicators, recipe, evaluate,
    prepare_result_for_print)
from ringo_bmasreport.views import sachbericht as evaluate_view
from ringo_printtemplate.views import print_template


program = "pwe"
# add program specific indicators. See issue2187.
indicators['RI'].append(('34', u'Bei der Teilnehmenden hat ein Übergang von geringfügiger in sozialversicherungspflichtige Beschäftigung stattgefunden'))
indicators['RI'].append(('PWE1',
u'Zentraler Ergebnisindikator: Teilnehmerinnen, die nach ihrer Teilnahme  einen Arbeitsplatz haben, auf Arbeitsuche sind oder für den Arbeitsmarkt  aktiviert wurden. (Dies ist die Anzahl aller Teilnehmerinnen , die mindestens einen der o.g. Indikatoren erreicht haben.)'))

def derive_indicators(values):
    return to_bmas(values)


class DummyData(object):
    def __init__(self, str1, name="sachbericht"):
        self.data = str1
        self.name = name


@view_config(route_name='report_sachbericht',
             renderer='/sachbericht.mako')
def report(request):
    result = evaluate_view(request, "pwe", Participation, evaluate, recipe,
                           validate, derive_indicators, indicators, filters)
    return result

@view_config(route_name='report_print_sachbericht')
def print_report(request):
    result = evaluate_view(request, "pwe", Participation, evaluate, recipe,
                           validate, derive_indicators, indicators, filters,
                           getvalidate=True)
    result = prepare_result_for_print(result, request)
    return print_template(request, result,
        DummyData("@pwe:pwe/static/sachbericht_vorlage.odt"))
